-----------------------------------------------------------------------------------------------------------------
--51.
CREATE TABLE TB_DEPT_51
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR(50)
, CONSTRAINT TB_DEPT_51_PK PRIMARY KEY (DEPT_NO)
);

INSERT INTO TB_DEPT_51 (DEPT_NO, DEPT_NM ) VALUES ( 'D101', 'Ͱ');
INSERT INTO TB_DEPT_51 (DEPT_NO, DEPT_NM ) VALUES ( 'D102', '̽㰳');

COMMIT;

CREATE TABLE TB_EMP_51
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4)
, CONSTRAINT TB_EMP_51_PK PRIMARY KEY (EMP_NO)
)
;

ALTER TABLE TB_EMP_51
ADD CONSTRAINTS FK_TB_EMP_51 FOREIGN KEY (DEPT_NO)
REFERENCES TB_DEPT_51 (DEPT_NO)
;

INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E001', '̰', 'SQL', 'D101');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E002', '̼', 'SQL', 'D101');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E003', '輱', '̽㰳', 'D102');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E004', '', '̽㰳', 'D102');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E005', 'ڼ', '̽㰳', 'D102');
INSERT INTO TB_EMP_51 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E006', 'ڼ', 'ڹٰ', NULL);

COMMIT;

SELECT NVL(B.EMP_NO , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM , '(Null)') AS B_EMP_NM
     , NVL(B.JOB_NM , '(Null)') AS B_JOB_NM
     , NVL(B.DEPT_NO, '(Null)') AS B_DEPT_NO
     , NVL(A.DEPT_NO, '(Null)') AS A_DEPT_NO
     , NVL(A.DEPT_NM, '(Null)') AS A_DEPT_NM
  FROM TB_DEPT_51 A RIGHT OUTER JOIN TB_EMP_51 B
  ON (
          A.DEPT_NO = B.DEPT_NO AND A.DEPT_NO = 'D101'
      AND B.DEPT_NO IS NOT NULL
     )
  ORDER BY B.EMP_NO
  ;

-------------------------------------------------------------------------------------------------------------
--52.
CREATE TABLE TB_DEPT_52
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR(50)
);

INSERT INTO TB_DEPT_52 (DEPT_NO, DEPT_NM ) VALUES ( 'D101', 'Ͱ');
INSERT INTO TB_DEPT_52 (DEPT_NO, DEPT_NM ) VALUES ( 'D102', '̽㰳');
INSERT INTO TB_DEPT_52 (DEPT_NO, DEPT_NM ) VALUES ( NULL  , 'ڹٰ');

COMMIT;

CREATE TABLE TB_EMP_52
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4)
)
;

INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E001', '̰', 'SQL', 'D101');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E002', '̼', 'SQL', 'D101');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E003', '輱', '̽㰳', NULL);
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E004', '', '̽㰳', 'D102');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E005', 'ڼ', '̽㰳', 'D102');
INSERT INTO TB_EMP_52 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO ) VALUES ('E006', 'ڼ', 'ڹٰ', NULL);

COMMIT;


SELECT NVL(A.DEPT_NO , '(Null)') AS A_DEPT_NO
     , NVL(A.DEPT_NM , '(Null)') AS A_DEPT_NM
     , NVL(B.EMP_NO  , '(Null)') AS B_EMP_NO
     , NVL(B.EMP_NM  , '(Null)') AS B_EMP_NM
     , NVL(B.JOB_NM  , '(Null)') AS B_JOB_NM
     , NVL(B.DEPT_NO , '(Null)') AS B_DEPT_NO
FROM TB_DEPT_52 A FULL OUTER JOIN TB_EMP_52 B
ON (A.DEPT_NO = B.DEPT_NO)
ORDER BY A.DEPT_NO DESC
;
-------------------------------------------------------------------------------------------------------------
--54.
CREATE TABLE TB_ORD_54
(
      ORD_NO CHAR(8)
    , ORD_DE CHAR(8)
    , ORD_TM CHAR(6)
    , PRDT_CD CHAR(4)
    , ORD_CNT NUMBER(10)
    , ORD_AMT NUMBER(10)
    , CONSTRAINT TB_ORD_54_PK PRIMARY KEY (ORD_NO)
)
;

INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000001', '20201113', '103610', 'P001', 1, 42000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000002', '20201113', '103756', 'P001', 1, 42000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000003', '20201113', '103757', 'P002', 1, 38000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000004', '20201113', '103814', 'P002', 1, 38000);
INSERT INTO TB_ORD_54 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
     VALUES ('10000005', '20201113', '103942', 'P003', 1, 56000);

COMMIT;

SELECT PRDT_CD FROM TB_ORD_54 WHERE PRDT_CD = 'P001'
UNION ALL
SELECT PRDT_CD FROM TB_ORD_54 WHERE PRDT_CD = 'P002'
MINUS
SELECT PRDT_CD FROM TB_ORD_54 WHERE PRDT_CD = 'P003'
ORDER BY PRDT_CD DESC
;
-------------------------------------------------------------------------------------------------------------
--55.
CREATE TABLE TB_DEPT_55
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR2(50) NOT NULL
, UPPER_DEPT_NO CHAR(4) NULL
, CONSTRAINT TB_DEPT_55_PK PRIMARY KEY(DEPT_NO)
)
;

INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D001', 'ȸ', NULL);
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D002', '', 'D001');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D003', 'ͱ', 'D002');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D004', 'SQL', 'D003');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D005', '̽㰳', 'D003');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D006', 'R', 'D003');

INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D007', '', 'D001');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D008', '', 'D007');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D009', '', 'D008');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D010', '߰߱', 'D008');
INSERT INTO TB_DEPT_55 (DEPT_NO, DEPT_NM, UPPER_DEPT_NO) VALUES ('D011', '߼ұ', 'D008');

COMMIT;

SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, 'ֻμ') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NOT NULL
  CONNECT BY PRIOR DEPT_NO = UPPER_DEPT_NO
;

SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, 'ֻμ') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NOT NULL
  CONNECT BY DEPT_NO = PRIOR UPPER_DEPT_NO
;


SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, 'ֻμ') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NULL
  CONNECT BY DEPT_NO = PRIOR UPPER_DEPT_NO
;

SELECT DEPT_NO
     , LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , NVL(UPPER_DEPT_NO, 'ֻμ') AS UPPER_DEPT_NO
  FROM TB_DEPT_55
  START WITH UPPER_DEPT_NO IS NULL
  CONNECT BY PRIOR DEPT_NO = UPPER_DEPT_NO
;

-------------------------------------------------------------------------------------------------------------
--55.
SELECT ROWNUM AS RNUM
FROM DUAL
CONNECT BY LEVEL <= 10;

-------------------------------------------------------------------------------------------------------------
--58.
CREATE TABLE TB_ORD_58
(
  ORD_NO CHAR(8)
, ORD_DE CHAR(8)
, ORD_TM CHAR(6)
, PRDT_CD CHAR(4)
, ORD_CNT NUMBER(10)
, ORD_AMT NUMBER(10)
, CONSTRAINT TB_ORD_58_PK PRIMARY KEY (ORD_NO)
)
;

INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000001', '20201113', '103610', 'P001', 1, 42000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000002', '20201113', '103756', 'P001', 1, 42000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000003', '20201113', '103757', 'P002', 1, 38000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000004', '20201113', '103814', 'P002', 1, 38000);
INSERT INTO TB_ORD_58 (ORD_NO, ORD_DE, ORD_TM, PRDT_CD, ORD_CNT, ORD_AMT )
VALUES ('10000005', '20201113', '103942', 'P003', 1, 56000);

COMMIT;

SELECT NVL(SUM(A.ORD_AMT), '0') AS TOT_ORD_AMT
FROM TB_ORD_58 A
WHERE A.ORD_AMT >= ( SELECT AVG(K.ORD_AMT)
                   FROM TB_ORD_58 K
                  WHERE K.PRDT_CD = 'P001'
               );
-------------------------------------------------------------------------------------------------------------
--60.
CREATE TABLE TB_CUST_60
(
  CUST_NO CHAR(7)
, CUST_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NULL
, CONSTRAINT TB_CUST_60_PK PRIMARY KEY (CUST_NO)
)
;

INSERT INTO TB_CUST_60 (CUST_NO, CUST_NM, JOB_NM) VALUES ('1000001', '̰', 'SQL');
INSERT INTO TB_CUST_60 (CUST_NO, CUST_NM, JOB_NM) VALUES ('1000002', '̼', '̽㰳');
INSERT INTO TB_CUST_60 (CUST_NO, CUST_NM, JOB_NM) VALUES ('1000003', '', NULL);

CREATE TABLE TB_PRDT_60
(
  PRDT_CD CHAR(4)
, PRDT_NM VARCHAR2(50) NOT NULL
, PRDT_PRC NUMBER(10)
, CONSTRAINT TB_PRDT_60_PK PRIMARY KEY (PRDT_CD)
)
;

INSERT INTO TB_PRDT_60 (PRDT_CD, PRDT_NM, PRDT_PRC ) VALUES ('P001', 'LG׷15ġ', 1580000);
INSERT INTO TB_PRDT_60 (PRDT_CD, PRDT_NM, PRDT_PRC ) VALUES ('P002', 'ＺƼ15ġ', 1680000);


CREATE TABLE TB_ORD_60
(
  ORD_NO CHAR(8)
, ORD_DT DATE NOT NULL
, CUST_NO CHAR(7) NOT NULL
, PRDT_CD CHAR(4) NOT NULL
, ORD_CNT NUMBER(10)
, ORD_AMT NUMBER(10)
, CONSTRAINT TB_ORD_60_PK PRIMARY KEY (ORD_NO)
)
;

INSERT INTO TB_ORD_60 (ORD_NO, ORD_DT, CUST_NO, PRDT_CD, ORD_CNT, ORD_AMT  )
     VALUES ('10000001', TO_DATE('20201113145812', 'YYYYMMDDHH24MISS'), '1000001', 'P001', 1, 1580000);

INSERT INTO TB_ORD_60 (ORD_NO, ORD_DT, CUST_NO, PRDT_CD, ORD_CNT, ORD_AMT  )
     VALUES ('10000002', TO_DATE('20201113154457', 'YYYYMMDDHH24MISS'), '1000002', 'P002', 2, 3360000);

INSERT INTO TB_ORD_60 (ORD_NO, ORD_DT, CUST_NO, PRDT_CD, ORD_CNT, ORD_AMT  )
     VALUES ('10000003', TO_DATE('20201113182212', 'YYYYMMDDHH24MISS'), '1000003', 'P002', 1, 1680000);


COMMIT;

SELECT A.JOB_NM, B.PRDT_CD, COUNT(*) AS CNT, SUM(B.ORD_AMT) AS ORD_AMT_TOT
FROM TB_CUST_60 A
   , TB_ORD_60 B
   , TB_PRDT_60 C
WHERE A.CUST_NO = B.CUST_NO
AND B.PRDT_CD = C.PRDT_CD
GROUP BY ROLLUP(A.JOB_NM, B.PRDT_CD)
;

-------------------------------------------------------------------------------------------------------------
--63.
CREATE TABLE TB_EMP_63
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4) NOT NULL
, DEPT_NM VARCHAR2(50) NOT NULL
, CUR_SAL NUMBER(10)
, CONSTRAINT TB_EMP_63_PK PRIMARY KEY (EMP_NO)
)
;


INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E001', '̰', 'D001', 'SQL', 75000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E002', '̼', 'D001', 'SQL', 70000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E003', '', 'D001', 'SQL', 70000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E004', 'ڹ', 'D001', 'SQL', 75000000);
INSERT INTO TB_EMP_63 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E005', '', 'D003', 'SQLƩ', 95000000);

COMMIT;

SELECT EMP_NO
    , DEPT_NO
    , CUR_SAL
    , RANK() OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS RN1
    , DENSE_RANK() OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS RN2
    , ROW_NUMBER() OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS RN3
FROM TB_EMP_63
;

-------------------------------------------------------------------------------------------------------------
--64.
CREATE TABLE TB_EMP_64
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4) NOT NULL
, DEPT_NM VARCHAR2(50) NOT NULL
, CUR_SAL NUMBER(10)
, CONSTRAINT TB_EMP_64_PK PRIMARY KEY (EMP_NO)
)
;


INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E001', '̰', 'D001', 'SQL', 55000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E002', '̼', 'D001', 'SQL', 60000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E003', '', 'D001', 'SQL', 65000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E004', 'ڹ', 'D001', 'SQL', 70000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E005', '', 'D003', 'SQLƩ', 75000000);
INSERT INTO TB_EMP_64 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E006', '', 'D003', 'SQLƩ', 80000000);

COMMIT;

SELECT EMP_NO
     , EMP_NM
     , NTILE(6) OVER(ORDER BY CUR_SAL DESC) AS RN1
     , ROW_NUMBER() OVER(ORDER BY CUR_SAL DESC) AS RN2
     , RANK() OVER(ORDER BY CUR_SAL DESC) AS RN3
     , DENSE_RANK() OVER(ORDER BY CUR_SAL DESC) AS RN4
  FROM TB_EMP_64
;

-------------------------------------------------------------------------------------------------------------
--65.
CREATE TABLE TB_EMP_65
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(4) NOT NULL
, DEPT_NM VARCHAR2(50) NOT NULL
, CUR_SAL NUMBER(10)
, CONSTRAINT TB_EMP_65_PK PRIMARY KEY (EMP_NO)
)
;


INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E001', '̰', 'D001', 'SQL', 55000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E002', '̼', 'D001', 'SQL', 60000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E003', '', 'D001', 'SQL', NULL);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E004', 'ڹ', 'D002', 'SQLƩ', 70000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E005', '', 'D002', 'SQLƩ', 75000000);

INSERT INTO TB_EMP_65 (EMP_NO, EMP_NM, DEPT_NO, DEPT_NM, CUR_SAL )
VALUES ('E007', '̰˼', 'D002', 'SQLƩ', NULL);


COMMIT;

SELECT
       A.EMP_NO
     , A.EMP_NM
     , A.DEPT_NO
     , NVL(TO_CHAR(A.MAX_CUR_SAL), '(Null)') AS MAX_CUR_SAL
  FROM
(
SELECT EMP_NO
     , EMP_NM
     , DEPT_NO
     , MAX(CUR_SAL) OVER(PARTITION BY DEPT_NO ORDER BY CUR_SAL DESC) AS MAX_CUR_SAL
  FROM TB_EMP_65
) A
;
-------------------------------------------------------------------------------------------------------------
--70.
CREATE TABLE TB_EMP_70
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_70_PK PRIMARY KEY(EMP_NO)
)
;


INSERT INTO TB_EMP_70 VALUES ('100001', '̰', 'SQL'     , 80000000, 'D101');
INSERT INTO TB_EMP_70 VALUES ('100002', '̵', 'ν', 60000000, 'D101');

INSERT INTO TB_EMP_70 VALUES ('100003', 'ö', 'Ͼ', 40000000, 'D102');
INSERT INTO TB_EMP_70 VALUES ('100004', 'ڻ', '쿣Ͼ', 20000000, 'D102');

COMMIT;

SELECT A.EMP_NO
     , A.EMP_NM
     , NTILE(2) OVER (ORDER BY CUR_SAL DESC) AS CUR_SAL_SE
     , CUR_SAL
  FROM TB_EMP_70 A
;
-------------------------------------------------------------------------------------------------------------
--71.
CREATE TABLE TB_EMP_71
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, SEX_CD CHAR(1)
, BIRTH_DE CHAR(8) NOT NULL
, DEPT_CD CHAR(4)
);

ALTER TABLE TB_EMP_71
ADD CONSTRAINT TB_EMP_71_PK PRIMARY KEY (EMP_NO);

INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00001', '̰', '1', '19840718', 'D001');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00002', '̼', '2', '19940502', 'D001');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00003', 'ڰ', '1', '19830414', 'D002');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00004', 'ֿ', '2', '19920508', 'D002');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00005', 'ö', '1', '19860112', 'D003');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00006', '', '2', '19960218', 'D003');
INSERT INTO TB_EMP_71 (EMP_NO, EMP_NM, SEX_CD, BIRTH_DE, DEPT_CD)
VALUES ('E00007', '', '2', '19980218',  NULL );

COMMIT;

SELECT EMP_NO, EMP_NM, SEX_CD, COUNT(DEPT_CD) OVER(PARTITION BY SEX_CD) AS CNT
  FROM TB_EMP_71
  ORDER BY EMP_NO
;
-------------------------------------------------------------------------------------------------------------
--72.
CREATE TABLE TB_EMP_72
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_72_PK PRIMARY KEY(EMP_NO)
);

INSERT INTO TB_EMP_72 VALUES ('100001', '̰', 'SQL', 45000000, 'D101');
INSERT INTO TB_EMP_72 VALUES ('100002', '̵', 'SQL', 40000000, 'D101');
INSERT INTO TB_EMP_72 VALUES ('100003', 'ö', 'SQL', 40000000, 'D102');
INSERT INTO TB_EMP_72 VALUES ('100004', 'ڻ', 'SQL', 35000000, 'D102');
INSERT INTO TB_EMP_72 VALUES ('100005', '', 'SQL', 50000000, 'D103');
INSERT INTO TB_EMP_72 VALUES ('100006', 'ٿ', 'SQL', 45000000, 'D103');
INSERT INTO TB_EMP_72 VALUES ('100007', 'ڼ', 'SQL', 65000000, 'D104');
INSERT INTO TB_EMP_72 VALUES ('100008', '輺', 'SQL', 60000000, 'D104');
INSERT INTO TB_EMP_72 VALUES ('100009', '߻', 'SQL', 35000000, 'D105');
INSERT INTO TB_EMP_72 VALUES ('100010', 'ڳ', 'SQL', 30000000, 'D105');

COMMIT;


SELECT SUM(DENSE_RANK_CUR_SAL) SUM_DENSE_RANK_CUR_SAL
  FROM
     (
      SELECT DISTINCT DENSE_RANK() OVER (ORDER BY CUR_SAL) DENSE_RANK_CUR_SAL
        FROM TB_EMP_72
     )
;
-------------------------------------------------------------------------------------------------------------
--74.
CREATE TABLE TB_DEPT_74
(
  DEPT_CD CHAR(4)
, DEPT_NM VARCHAR2(150) NOT NULL
, CONSTRAINT TB_DEPT_74_PK PRIMARY KEY(DEPT_CD)
)
;

CREATE TABLE TB_EMP_74
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_74_PK PRIMARY KEY(EMP_NO)
)
;

ALTER TABLE TB_EMP_74
ADD CONSTRAINT TB_EMP_74_FK FOREIGN KEY (DEPT_CD)
   REFERENCES TB_DEPT_74 (DEPT_CD);

INSERT INTO TB_DEPT_74 VALUES ('D101', 'Ͱ'        );
INSERT INTO TB_DEPT_74 VALUES ('D102', '÷'      );
INSERT INTO TB_DEPT_74 VALUES ('D103', 'ͻ̾'    );
INSERT INTO TB_DEPT_74 VALUES ('D104', 'ͼ'        );
INSERT INTO TB_DEPT_74 VALUES ('D105', '͸̱׷̼');

COMMIT;

INSERT INTO TB_EMP_74 VALUES ('100001', '̰', 'SQL'     , 45000000, 'D101');
INSERT INTO TB_EMP_74 VALUES ('100002', '̵', 'ν', 40000000, 'D101');

INSERT INTO TB_EMP_74 VALUES ('100003', 'ö', 'Ͼ', 40000000, 'D102');
INSERT INTO TB_EMP_74 VALUES ('100004', 'ڻ', '쿣Ͼ', 35000000, 'D102');


INSERT INTO TB_EMP_74 VALUES ('100005', '', 'R'       , 50000000, 'D103');
INSERT INTO TB_EMP_74 VALUES ('100006', 'ٿ', '̽㰳'  , 45000000, 'D103');


INSERT INTO TB_EMP_74 VALUES ('100007', 'ڼ', 'ŬƩ'    , 65000000, 'D104');
INSERT INTO TB_EMP_74 VALUES ('100008', '輺', '¼ҽƩ'  , 60000000, 'D104');

INSERT INTO TB_EMP_74 VALUES ('100009', '߻', ''      , 35000000, 'D105');
INSERT INTO TB_EMP_74 VALUES ('100010', 'ڳ', 'ڹٰ'    , 30000000, 'D105');

COMMIT;

SELECT B.DEPT_NM
     , AVG(A.CUR_SAL) AS CUR_SAL
  FROM TB_EMP_74 A
     , TB_DEPT_74 B
 WHERE A.DEPT_CD = B.DEPT_CD
 GROUP BY ROLLUP (B.DEPT_NM)
;
-------------------------------------------------------------------------------------------------------------
--76.
CREATE TABLE TB_EMP_76
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_76_PK PRIMARY KEY(EMP_NO)
)
;


INSERT INTO TB_EMP_76 VALUES ('100001', '̰', 'SQL'     , 80000000, 'D101');
INSERT INTO TB_EMP_76 VALUES ('100002', '̵', 'ν', 60000000, 'D101');

INSERT INTO TB_EMP_76 VALUES ('100003', 'ö', 'Ͼ', 40000000, 'D102');
INSERT INTO TB_EMP_76 VALUES ('100004', 'ڻ', '쿣Ͼ', 20000000, 'D102');

COMMIT;

SELECT SUM(CUR_SAL)/10000
  FROM
 (
  SELECT A.EMP_NO
       , A.EMP_NM
       , LAG(CUR_SAL) OVER(ORDER BY CUR_SAL) AS LAG_CUR_SAL
       , LEAD(CUR_SAL) OVER(ORDER BY CUR_SAL) AS LEAD_CUR_SAL
       , CUR_SAL
    FROM TB_EMP_76 A
   ORDER BY A.EMP_NO
 ) A
 WHERE LAG_CUR_SAL IS NULL
    OR LEAD_CUR_SAL IS NULL
;
-------------------------------------------------------------------------------------------------------------
--77.
CREATE TABLE TB_DEPT_77
(
  DEPT_CD CHAR(4)
, DEPT_NM VARCHAR2(150) NOT NULL
, CONSTRAINT TB_DEPT_77_PK PRIMARY KEY(DEPT_CD)
)
;
CREATE TABLE TB_EMP_77
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(150) NULL
, CUR_SAL NUMBER
, DEPT_CD CHAR(4)
, CONSTRAINT TB_EMP_77_PK PRIMARY KEY(EMP_NO)
)
;

ALTER TABLE TB_EMP_77
ADD CONSTRAINT TB_EMP_77_FK FOREIGN KEY (DEPT_CD)
    REFERENCES TB_DEPT_77 (DEPT_CD);


INSERT INTO TB_DEPT_77 VALUES ('D101', 'Ͱ'        );
INSERT INTO TB_DEPT_77 VALUES ('D102', '÷'      );
INSERT INTO TB_DEPT_77 VALUES ('D103', 'ͻ̾'    );
INSERT INTO TB_DEPT_77 VALUES ('D104', 'ͼ'        );
INSERT INTO TB_DEPT_77 VALUES ('D105', '͸̱׷̼');
COMMIT;

INSERT INTO TB_EMP_77 VALUES ('100001', '̰', 'SQL', 45000000, 'D101');
INSERT INTO TB_EMP_77 VALUES ('100002', '̵', 'SQL', 40000000, 'D101');
INSERT INTO TB_EMP_77 VALUES ('100003', 'ö', 'SQL', 40000000, 'D102');
INSERT INTO TB_EMP_77 VALUES ('100004', 'ڻ', 'SQL', 35000000, 'D102');
INSERT INTO TB_EMP_77 VALUES ('100005', '', 'SQL', 50000000, 'D103');
INSERT INTO TB_EMP_77 VALUES ('100006', 'ٿ', 'SQL', 45000000, 'D103');
INSERT INTO TB_EMP_77 VALUES ('100007', 'ڼ', 'SQL', 65000000, 'D104');
INSERT INTO TB_EMP_77 VALUES ('100008', '輺', 'SQL', 60000000, 'D104');
INSERT INTO TB_EMP_77 VALUES ('100009', '߻', 'SQL', 35000000, 'D105');
INSERT INTO TB_EMP_77 VALUES ('100010', 'ڳ', 'SQL', 30000000, 'D105');
COMMIT;

SELECT JOB_NM
     , B.DEPT_NM
     , AVG(A.CUR_SAL) AS CUR_SAL
  FROM TB_EMP_77 A
     , TB_DEPT_77 B
WHERE A.DEPT_CD = B.DEPT_CD
GROUP BY ROLLUP (A.JOB_NM, B.DEPT_NM)
;
-------------------------------------------------------------------------------------------------------------
--78.
CREATE TABLE TB_DEPT_78
(
  DEPT_NO CHAR(6)
, DEPT_NM VARCHAR2(150) NOT NULL
, UPPER_DEPT_NO CHAR(6) NULL
, CONSTRAINT TB_DEPT_78_PK PRIMARY KEY (DEPT_NO)
)
;

INSERT INTO TB_DEPT_78 VALUES ('D00001', 'ȸ'        ,  NULL   );

INSERT INTO TB_DEPT_78 VALUES ('D00002', ''      , 'D00001');
INSERT INTO TB_DEPT_78 VALUES ('D00003', ''      , 'D00001');

INSERT INTO TB_DEPT_78 VALUES ('D00004', ''    , 'D00002');
INSERT INTO TB_DEPT_78 VALUES ('D00005', 'ؿܿ'    , 'D00002');

INSERT INTO TB_DEPT_78 VALUES ('D00006', '߻'    , 'D00003');
INSERT INTO TB_DEPT_78 VALUES ('D00007', 'ͻ'  , 'D00003');

INSERT INTO TB_DEPT_78 VALUES ('D00008', ''    , 'D00004');
INSERT INTO TB_DEPT_78 VALUES ('D00009', ''    , 'D00004');

INSERT INTO TB_DEPT_78 VALUES ('D00010', 'Ϲ̿'    , 'D00005');
INSERT INTO TB_DEPT_78 VALUES ('D00011', '̿'    , 'D00005');

INSERT INTO TB_DEPT_78 VALUES ('D00012', ''    , 'D00006');
INSERT INTO TB_DEPT_78 VALUES ('D00013', 'ȭ鰳'    , 'D00006');

INSERT INTO TB_DEPT_78 VALUES ('D00014', 'Ŭ'  , 'D00007');
INSERT INTO TB_DEPT_78 VALUES ('D00015', '¼ҽ', 'D00007');

COMMIT;

SELECT DEPT_NO, LPAD(' ', 4 * (LEVEL -1)) || DEPT_NM AS DEPT_NM
     , UPPER_DEPT_NO
     , LEVEL AS LVL
 FROM TB_DEPT_78
 START WITH UPPER_DEPT_NO IS NULL
 CONNECT BY PRIOR DEPT_NO = UPPER_DEPT_NO
              AND DEPT_NM LIKE '%'
 ;
-------------------------------------------------------------------------------------------------------------
--80.
CREATE TABLE TB_DEPT_80
(
  DEPT_NO CHAR(6)
, DEPT_NM VARCHAR2(150) NOT NULL
, CONSTRAINT TB_DEPT_80_PK PRIMARY KEY (DEPT_NO)
)
;

INSERT INTO TB_DEPT_80 VALUES ('D00001', 'Dataðȭ');
INSERT INTO TB_DEPT_80 VALUES ('D00002', 'Data÷');
INSERT INTO TB_DEPT_80 VALUES ('D00003', 'Dataм'  );

COMMIT;

CREATE TABLE TB_EMP_80
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO CHAR(6)
, CONSTRAINT TB_EMP_80_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_80 VALUES ('E00001', '̰', 'D00001');
INSERT INTO TB_EMP_80 VALUES ('E00002', '̼', 'D00001');
INSERT INTO TB_EMP_80 VALUES ('E00003', 'ȿ', 'D00002');
INSERT INTO TB_EMP_80 VALUES ('E00004', 'ڻ', 'D00003');


COMMIT;

ALTER TABLE TB_EMP_80
ADD CONSTRAINTS TB_EMP_80_FK FOREIGN KEY (DEPT_NO)
REFERENCES TB_DEPT_80 (DEPT_NO)
;

SELECT A.DEPT_NO
     , A.DEPT_NM
     , NVL(B.EMP_NO, 'NULL') AS EMP_NO
     , NVL(B.EMP_NM, 'NULL') AS EMP_NM
  FROM TB_DEPT_80 A LEFT OUTER JOIN TB_EMP_80 B
    ON (A.DEPT_NO = B.DEPT_NO AND A.DEPT_NM = 'Dataðȭ')
  WHERE A.DEPT_NO IS NOT NULL
;

